﻿using System.Xml;

namespace StellarWaterPoint.Customers
{
    public partial class Central : Form
    {
        public Central()
        {
            InitializeComponent();
        }

        private void ShowCustomers()
        {
            int i = 1;

            lvwCustomers.Items.Clear();

            XmlDocument xdCustomers = new XmlDocument();
            string? strCustomers = @"C:\Stellar Water Point\Customers.xml";

            FileInfo? fiCustomers = new FileInfo(strCustomers);

            if (fiCustomers.Exists)
            {
                using (FileStream? fsCustomers = new FileStream(fiCustomers.FullName, FileMode.Open, FileAccess.Read, FileShare.Read))
                {
                    xdCustomers.Load(fsCustomers);
                    XmlNodeList xnlCustomers = xdCustomers.DocumentElement!.ChildNodes;

                    foreach (XmlNode xnCustomer in xnlCustomers)
                    {
                        ListViewItem lviCustomer = new ListViewItem(i.ToString());

                        lviCustomer.SubItems.Add(xnCustomer.FirstChild!.InnerText);   // Account #
                        lviCustomer.SubItems.Add(xnCustomer.FirstChild.NextSibling!.InnerText);   // Meter #
                        lviCustomer.SubItems.Add(xnCustomer.FirstChild.NextSibling.NextSibling!.InnerText); // First Name
                        lviCustomer.SubItems.Add(xnCustomer.FirstChild.NextSibling.NextSibling.NextSibling!.InnerText);   // Last Name
                        lviCustomer.SubItems.Add(xnCustomer.FirstChild.NextSibling.NextSibling.NextSibling.NextSibling!.InnerText);   // Address
                        lviCustomer.SubItems.Add(xnCustomer.FirstChild.NextSibling.NextSibling.NextSibling.NextSibling!.NextSibling!.InnerText);   // City
                        lviCustomer.SubItems.Add(xnCustomer.FirstChild.NextSibling.NextSibling.NextSibling.NextSibling!.NextSibling!.NextSibling!.InnerText);   // County
                        lviCustomer.SubItems.Add(xnCustomer.FirstChild.NextSibling.NextSibling.NextSibling.NextSibling!.NextSibling!.NextSibling!.NextSibling!.InnerText);   // State
                        lviCustomer.SubItems.Add(xnCustomer.FirstChild.NextSibling.NextSibling.NextSibling.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.InnerText); // ZIP-Code

                        lvwCustomers.Items.Add(lviCustomer);

                        i++;
                    }
                }
            }
        }

        private void Central_Load(object sender, EventArgs e)
        {
            ShowCustomers();
        }

        private void btnNewCustomerAccount_Click(object sender, EventArgs e)
        {
            FileInfo? fiCustomers = null;
            FileStream? fsCustomers = null;
            Create create = new Create();
            XmlDocument xdCustomers = new XmlDocument();
            string? strCustomers = @"C:\Stellar Water Point\Customers.xml";

            if (create.ShowDialog() == DialogResult.OK)
            {
                fiCustomers = new FileInfo(strCustomers);

                if (fiCustomers.Exists)
                {
                    using (fsCustomers = new FileStream(fiCustomers.FullName, FileMode.Open, FileAccess.Read, FileShare.Read))
                    {
                        xdCustomers.Load(fsCustomers);
                    }
                }
                else
                {
                    using (fsCustomers = new FileStream(fiCustomers.FullName, FileMode.Create, FileAccess.Write, FileShare.Write))
                    {
                        xdCustomers.LoadXml("<?xml version=\"1.0\" encoding=\"utf-8\"?>" +
                                              "<customers></customers>");
                        xdCustomers.Save(fsCustomers);
                    }
                }

                using (fsCustomers = new FileStream(fiCustomers.FullName, FileMode.OpenOrCreate, FileAccess.ReadWrite, FileShare.ReadWrite))
                {
                    XmlElement xeCustomer = xdCustomers.CreateElement("customer");

                    xeCustomer.InnerXml = "<account-number>" + create.mtbAccountNumber.Text + "</account-number>" +
                                            "<meter-number>" + create.mtbMeterNumber.Text   + "</meter-number>"   +
                                            "<first-name>"   + create.txtFirstName.Text     + "</first-name>"     +
                                            "<last-name>"    + create.txtLastName.Text      + "</last-name>"      +
                                            "<address>"      + create.txtAddress.Text       + "</address>"        +
                                            "<city>"         + create.txtCity.Text          + "</city>"           +
                                            "<county>"       + create.txtCounty.Text        + "</county>"         +
                                            "<state>"        + create.txtState.Text         + "</state>"          +
                                            "<zip-code>"     + create.mtbZIPCode.Text       + "</zip-code>";
                    xdCustomers.DocumentElement!.AppendChild(xeCustomer);
                    xdCustomers.Save(fsCustomers);
                }
            }

            ShowCustomers();
        }

        private void btnViewCustomerAccount_Click(object sender, EventArgs e)
        {
            Details editor = new Details();

            editor.ShowDialog();
        }

        private void btnEditCustomerAccount_Click(object sender, EventArgs e)
        {
            Editor editor = new Editor();

            editor.ShowDialog();

            ShowCustomers();
        }

        private void btnDeleteCustomerAccount_Click(object sender, EventArgs e)
        {
            Delete delete = new Delete();

            delete.ShowDialog();

            ShowCustomers();
        }

        private void btnClose_Click(object sender, EventArgs e)
        {
            Close();
        }
    }
}
