﻿using System.Xml;

namespace StellarWaterPoint.Customers
{
    public partial class Delete : Form
    {
        public Delete()
        {
            InitializeComponent();
        }

        private void btnFindCustomerAccount_Click(object sender, EventArgs e)
        {
            XmlDocument xdCustomers = new XmlDocument();
            string? strCustomers = @"C:\Stellar Water Point\Customers.xml";

            FileInfo? fiCustomers = new FileInfo(strCustomers);

            if (fiCustomers.Exists)
            {
                using (FileStream? fsCustomers = new FileStream(fiCustomers.FullName, FileMode.Open, FileAccess.Read, FileShare.Read))
                {
                    xdCustomers.Load(fsCustomers);
                    XmlNodeList xnlCustomers = xdCustomers.DocumentElement!.SelectNodes("//account-number[.='" + mtbAccountNumber.Text + "']")!;

                    foreach (XmlNode xnCustomer in xnlCustomers)
                    {
                        mtbMeterNumber.Text = xnCustomer.NextSibling!.InnerText;   // Meter #
                        txtFirstName.Text   = xnCustomer.NextSibling.NextSibling!.InnerText; // First Name
                        txtLastName.Text    = xnCustomer.NextSibling.NextSibling.NextSibling!.InnerText;   // Last Name
                        txtAddress.Text     = xnCustomer.NextSibling.NextSibling.NextSibling.NextSibling!.InnerText;   // Address
                        txtCity.Text        = xnCustomer.NextSibling.NextSibling.NextSibling.NextSibling!.NextSibling!.InnerText;   // City
                        txtCounty.Text      = xnCustomer.NextSibling.NextSibling.NextSibling.NextSibling!.NextSibling!.NextSibling!.InnerText;   // County
                        txtState.Text       = xnCustomer.NextSibling.NextSibling.NextSibling.NextSibling!.NextSibling!.NextSibling!.NextSibling!.InnerText;   // State
                        mtbZIPCode.Text     = xnCustomer.NextSibling.NextSibling.NextSibling.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.InnerText; // ZIP-Code
                    }
                }
            }

            XmlDocument xdWaterMeters = new XmlDocument();
            string? strWaterMeters = @"C:\Stellar Water Point\WaterMeters.xml";

            FileInfo? fiWaterMeters = new FileInfo(strWaterMeters);

            if (fiWaterMeters.Exists)
            {
                using (FileStream? fsWaterMeters = new FileStream(fiWaterMeters.FullName, FileMode.Open, FileAccess.Read, FileShare.Read))
                {
                    xdWaterMeters.Load(fsWaterMeters);
                    XmlNodeList xnlWaterMeters = xdWaterMeters.DocumentElement!.SelectNodes("//meter-number[.='" + mtbMeterNumber.Text + "']")!;

                    foreach (XmlNode xnWaterMeter in xnlWaterMeters)
                    {
                        txtMeterDetails.Text = xnWaterMeter.NextSibling!.InnerText + " " +
                                               xnWaterMeter.NextSibling.NextSibling!.InnerText + " (Meter Size: " +
                                               xnWaterMeter.NextSibling.NextSibling.NextSibling!.InnerText + ")";
                    }
                }
            }
        }

        private void btnDeleteCustomerAccount_Click(object sender, EventArgs e)
        {
            XmlDocument xdCustomers = new XmlDocument();
            string? strCustomers = @"C:\Stellar Water Point\Customers.xml";

            if (string.IsNullOrEmpty(mtbAccountNumber.Text))
            {
                MessageBox.Show("You must type an account number for the customer whose account you want to deleteone.",
                                "Stellar Water Point", MessageBoxButtons.OK, MessageBoxIcon.Information);
                return;
            }

            if (!File.Exists(strCustomers))
            {
                MessageBox.Show("There is no file for the customers accounts in the system.",
                                "Stellar Water Point",
                                MessageBoxButtons.OK, MessageBoxIcon.Information);
                return;
            }

            xdCustomers.Load(strCustomers);

            XmlNodeList xnlCustomers = xdCustomers.DocumentElement!.GetElementsByTagName("account-number");

            foreach (XmlNode xnCustomer in xnlCustomers)
            {
                if (xnCustomer.InnerText == mtbAccountNumber.Text)
                {
                    if (MessageBox.Show("Are you sure you want to remove this customer's account from the system?",
                                    "Stellar Water Point",
                                    MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes)
                    {
                        xdCustomers.DocumentElement.RemoveChild(xnCustomer.ParentNode!);
                        break;
                    }
                }
            }

            xdCustomers.Save(strCustomers);

            Close();
        }
    }
}
