﻿using System.Xml;

namespace StellarWaterPoint.WaterBills
{
    public partial class Delete : Form
    {
        public Delete()
        {
            InitializeComponent();
        }

        private void btnFindWaterBill_Click(object sender, EventArgs e)
        {
            if (string.IsNullOrEmpty(txtBillNumber.Text))
            {
                MessageBox.Show("You must type a bill number." +
                                "Otherwise, the account cannot be saved.",
                                "Stellar Water Point", MessageBoxButtons.OK);
                return;
            }

            string? strMeterNumber = null;

            FileStream? fsWaterBills  = null;
            XmlDocument xdWaterBills  = new XmlDocument();
            string      strWaterBills = @"C:\Stellar Water Point\WaterBills.xml";

            FileInfo?   fiWaterBills  = new FileInfo(strWaterBills);

            if (fiWaterBills.Exists)
            {
                using (fsWaterBills = new FileStream(fiWaterBills.FullName, FileMode.Open, FileAccess.Read, FileShare.Read))
                {
                    xdWaterBills.Load(fsWaterBills);
                    XmlNodeList xnlWaterBills = xdWaterBills.DocumentElement!.SelectNodes("//bill-number[.='" + txtBillNumber.Text + "']")!;

                    foreach (XmlNode xnWaterBill in xnlWaterBills)
                    {
                        mtbAccountNumber.Text          = xnWaterBill.NextSibling!.InnerText;
                        dtpMeterReadingStartDate.Value = DateTime.Parse(xnWaterBill.NextSibling!.NextSibling!.InnerText);
                        dtpMeterReadingEndDate.Value   = DateTime.Parse(xnWaterBill.NextSibling.NextSibling.NextSibling!.InnerText);
                        txtBillingDays.Text            = xnWaterBill.NextSibling.NextSibling.NextSibling!.NextSibling!.InnerText;
                        txtCounterReadingStart.Text    = xnWaterBill.NextSibling.NextSibling.NextSibling.NextSibling.NextSibling!.InnerText;
                        txtCounterReadingEnd.Text      = xnWaterBill.NextSibling.NextSibling.NextSibling.NextSibling.NextSibling!.NextSibling!.InnerText;
                        txtTotalGallons.Text           = xnWaterBill.NextSibling.NextSibling.NextSibling.NextSibling.NextSibling!.NextSibling!.NextSibling!.InnerText;
                        txtTotalCCF.Text               = xnWaterBill.NextSibling.NextSibling.NextSibling.NextSibling.NextSibling!.NextSibling!.NextSibling!.NextSibling!.InnerText;
                        txtFirstTierConsumption.Text   = xnWaterBill.NextSibling.NextSibling.NextSibling.NextSibling.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.InnerText;
                        txtSecondTierConsumption.Text  = xnWaterBill.NextSibling.NextSibling.NextSibling.NextSibling.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.InnerText;
                        txtLastTierConsumption.Text    = xnWaterBill.NextSibling.NextSibling.NextSibling.NextSibling.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.InnerText;
                        txtWaterCharges.Text           = xnWaterBill.NextSibling.NextSibling.NextSibling.NextSibling.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.InnerText;
                        txtSewerCharges.Text           = xnWaterBill.NextSibling.NextSibling.NextSibling.NextSibling.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.InnerText;
                        txtEnvironmentCharges.Text     = xnWaterBill.NextSibling.NextSibling.NextSibling.NextSibling.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.InnerText;
                        txtTotalCharges.Text           = xnWaterBill.NextSibling.NextSibling.NextSibling.NextSibling.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.InnerText;
                        txtLocalTaxes.Text             = xnWaterBill.NextSibling.NextSibling.NextSibling.NextSibling.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.InnerText;
                        txtStateTaxes.Text             = xnWaterBill.NextSibling.NextSibling.NextSibling.NextSibling.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.InnerText;
                        txtAmountDue.Text              = xnWaterBill.NextSibling.NextSibling.NextSibling.NextSibling.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.InnerText;
                        dtpPaymentDueDate.Value        = DateTime.Parse(xnWaterBill.NextSibling.NextSibling.NextSibling.NextSibling.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.InnerText);
                        txtLateAmountDue.Text          = xnWaterBill.NextSibling.NextSibling.NextSibling.NextSibling.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.InnerText;
                        dtpLatePaymentDueDate.Value    = DateTime.Parse(xnWaterBill.NextSibling.NextSibling.NextSibling.NextSibling.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.InnerText);
                    }
                }
            }

            XmlDocument xdCustomers  = new XmlDocument();
            string?     strCustomers = @"C:\Stellar Water Point\Customers.xml";

            FileInfo?   fiCustomers  = new FileInfo(strCustomers);

            if (fiCustomers.Exists)
            {
                using (FileStream? fsCustomers = new FileStream(fiCustomers.FullName, FileMode.Open, FileAccess.Read, FileShare.Read))
                {
                    xdCustomers.Load(fsCustomers);
                    XmlNodeList xnlCustomers = xdCustomers.DocumentElement!.SelectNodes("//account-number[.='" + mtbAccountNumber.Text + "']")!;

                    foreach (XmlNode xnCustomer in xnlCustomers)
                    {
                        strMeterNumber       = xnCustomer.NextSibling!.InnerText;   // Meter #
                        txtCustomerName.Text = xnCustomer.NextSibling.NextSibling!.InnerText + " " +
                                               xnCustomer.NextSibling.NextSibling.NextSibling!.InnerText;   // Custome Name
                        txtAddress.Text      = xnCustomer.NextSibling.NextSibling.NextSibling.NextSibling!.InnerText;   // Address
                        txtCity.Text         = xnCustomer.NextSibling.NextSibling.NextSibling.NextSibling!.NextSibling!.InnerText;   // City
                        txtCounty.Text       = xnCustomer.NextSibling.NextSibling.NextSibling.NextSibling!.NextSibling!.NextSibling!.InnerText;   // County
                        txtState.Text        = xnCustomer.NextSibling.NextSibling.NextSibling.NextSibling!.NextSibling!.NextSibling!.NextSibling!.InnerText;   // State
                        mtbZIPCode.Text      = xnCustomer.NextSibling.NextSibling.NextSibling.NextSibling!.NextSibling!.NextSibling!.NextSibling!.NextSibling!.InnerText; // ZIP-Code
                    }
                }
            }

            XmlDocument xdWaterMeters = new XmlDocument();
            string? strWaterMeters = @"C:\Stellar Water Point\WaterMeters.xml";

            FileInfo? fiWaterMeters = new FileInfo(strWaterMeters);

            if (fiWaterMeters.Exists)
            {
                using (FileStream? fsWaterMeters = new FileStream(fiWaterMeters.FullName, FileMode.Open, FileAccess.Read, FileShare.Read))
                {
                    xdWaterMeters.Load(fsWaterMeters);
                    XmlNodeList xnlWaterMeters = xdWaterMeters.DocumentElement!.SelectNodes("//meter-number[.='" + strMeterNumber + "']")!;

                    foreach (XmlNode xnWaterMeter in xnlWaterMeters)
                    {
                        txtMeterDetails.Text = xnWaterMeter.NextSibling!.InnerText + " " +
                                               xnWaterMeter.NextSibling.NextSibling!.InnerText + " (Meter Size: " +
                                               xnWaterMeter.NextSibling.NextSibling.NextSibling!.InnerText + ")";
                    }
                }
            }
        }

        private void btnDeleteWaterBill_Click(object sender, EventArgs e)
        {
            XmlDocument xdWaterMeters = new XmlDocument();
            string? strWaterMeters = @"C:\Stellar Water Point\WaterBills.xml";

            if (string.IsNullOrEmpty(mtbAccountNumber.Text))
            {
                MessageBox.Show("You must type a bill number for the water bill you want to delete.",
                                "Stellar Water Point", MessageBoxButtons.OK, MessageBoxIcon.Information);
                return;
            }

            if (!File.Exists(strWaterMeters))
            {
                MessageBox.Show("There is no file for the water bills in the system.",
                                "Stellar Water Point",
                                MessageBoxButtons.OK, MessageBoxIcon.Information);
                return;
            }

            xdWaterMeters.Load(strWaterMeters);

            XmlNodeList xnlWaterMeters = xdWaterMeters.DocumentElement!.GetElementsByTagName("bill-number");

            foreach (XmlNode xnWaterMeter in xnlWaterMeters)
            {
                if (xnWaterMeter.InnerText == txtBillNumber.Text)
                {
                    if (MessageBox.Show("Are you sure you want to delete this water bill from the system?",
                                        "Stellar Water Point",
                                        MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes)
                    {
                        xdWaterMeters.DocumentElement.RemoveChild(xnWaterMeter.ParentNode!);
                        break;
                    }
                }
            }

            xdWaterMeters.Save(strWaterMeters);

            Close();
        }

        private void btnClose_Click(object sender, EventArgs e)
        {
            Close();
        }
    }
}
