﻿using System.Xml;

namespace StellarWaterPoint.WaterMeters
{
    public partial class Central : Form
    {
        public Central()
        {
            InitializeComponent();
        }

        private void ShowWaterMeters()
        {
            lvwWaterMeters.Items.Clear();

            XmlDocument xdWaterMeters  = new XmlDocument();
            string?     strWaterMeters = @"C:\Stellar Water Point\WaterMeters.xml";

            FileInfo?   fiWaterMeters  = new FileInfo(strWaterMeters);

            if (fiWaterMeters.Exists)
            {
                using (FileStream? fsWaterMeters = new FileStream(fiWaterMeters.FullName, FileMode.Open, FileAccess.Read, FileShare.Read))
                {
                    xdWaterMeters.Load(fsWaterMeters);
                    XmlNodeList xnlWaterMeters = xdWaterMeters.DocumentElement!.ChildNodes;
                    
                    int i = 1;

                    foreach (XmlNode xnWaterMeter in xnlWaterMeters)
                    {
                        ListViewItem lviWaterMeter = new ListViewItem(i.ToString());

                        lviWaterMeter.SubItems.Add(xnWaterMeter.FirstChild!.InnerText);
                        lviWaterMeter.SubItems.Add(xnWaterMeter.FirstChild.NextSibling!.InnerText);
                        lviWaterMeter.SubItems.Add(xnWaterMeter.FirstChild.NextSibling.NextSibling!.InnerText);
                        lviWaterMeter.SubItems.Add(xnWaterMeter.FirstChild.NextSibling.NextSibling.NextSibling!.InnerText);

                        lvwWaterMeters.Items.Add(lviWaterMeter);

                        i++;
                    }
                }
            }
        }

        private void Central_Load(object sender, EventArgs e)
        {
            ShowWaterMeters();
        }

        private void btnNewWaterMeter_Click(object sender, EventArgs e)
        {
            Create      wm            = new();
            FileInfo?   fiWaterMeters = null;
            FileStream? fsWaterMeters = null;
            XmlDocument xdWaterMeters = new XmlDocument();
            string?     strWaterMeters = @"C:\Stellar Water Point\WaterMeters.xml";

            if (wm.ShowDialog() == DialogResult.OK)
            {
                fiWaterMeters = new FileInfo(strWaterMeters);

                if (fiWaterMeters.Exists)
                {
                    using (fsWaterMeters = new FileStream(fiWaterMeters.FullName, FileMode.Open, FileAccess.Read, FileShare.Read))
                    {
                        xdWaterMeters.Load(fsWaterMeters);
                    }
                }
                else
                {
                    using (fsWaterMeters = new FileStream(fiWaterMeters.FullName, FileMode.Create, FileAccess.Write, FileShare.Write))
                    {
                        xdWaterMeters.LoadXml("<?xml version=\"1.0\" encoding=\"utf-8\"?>" +
                                              "<water-meters></water-meters>");
                        xdWaterMeters.Save(fsWaterMeters);
                    }
                }

                using (fsWaterMeters = new FileStream(fiWaterMeters.FullName, FileMode.OpenOrCreate, FileAccess.ReadWrite, FileShare.ReadWrite))
                {
                    XmlElement xeWaterMeter = xdWaterMeters.CreateElement("water-meter");

                    xeWaterMeter.InnerXml   = "<meter-number>" + wm.mtbMeterNumber.Text + "</meter-number>" +
                                              "<make>"         + wm.txtMake.Text        + "</make>"         +
                                              "<model>"        + wm.txtModel.Text       + "</model>"        +
                                              "<meter-size>"   + wm.txtMeterSize.Text   + "</meter-size>";
                    xdWaterMeters.DocumentElement!.AppendChild(xeWaterMeter);
                    xdWaterMeters.Save(fsWaterMeters);
                }
            }

            ShowWaterMeters();
        }

        private void btnViewWaterMeter_Click(object sender, EventArgs e)
        {
            Details editor = new();

            editor.ShowDialog();
        }

        private void btnEditWaterMeter_Click(object sender, EventArgs e)
        {
            Editor editor = new();

            editor.ShowDialog();

            ShowWaterMeters();
        }

        private void btnDeleteWaterMeter_Click(object sender, EventArgs e)
        {
            Delete delete = new();

            delete.ShowDialog();

            ShowWaterMeters();
        }

        private void btnClose_Click(object sender, EventArgs e)
        {
            Close();
        }
    }
}
