﻿using System.Xml;

namespace StellarWaterPoint.WaterMeters
{
    public partial class Delete : Form
    {
        public Delete()
        {
            InitializeComponent();
        }

        private void btnFind_Click(object sender, EventArgs e)
        {
            XmlDocument xdWaterMeters = new XmlDocument();
            string? strWaterMeters = @"C:\Stellar Water Point\WaterMeters.xml";

            FileInfo? fiWaterMeters = new FileInfo(strWaterMeters);

            if (fiWaterMeters.Exists)
            {
                using (FileStream? fsWaterMeters = new FileStream(fiWaterMeters.FullName, FileMode.Open, FileAccess.Read, FileShare.Read))
                {
                    xdWaterMeters.Load(fsWaterMeters);
                    XmlNodeList xnlWaterMeters = xdWaterMeters.DocumentElement!.SelectNodes("//meter-number[.='" + mtbMeterNumber.Text + "']")!;

                    foreach (XmlNode xnWaterMeter in xnlWaterMeters)
                    {
                        txtMake.Text = xnWaterMeter.NextSibling!.InnerText;
                        txtModel.Text = xnWaterMeter.NextSibling.NextSibling!.InnerText;
                        txtMeterSize.Text = xnWaterMeter.NextSibling.NextSibling.NextSibling!.InnerText;
                    }
                }
            }
        }

        private void btnDeleteWaterMeter_Click(object sender, EventArgs e)
        {
            XmlDocument xdWaterMeters = new XmlDocument();
            string? strWaterMeters = @"C:\Stellar Water Point\WaterMeters.xml";

            if (string.IsNullOrEmpty(mtbMeterNumber.Text))
            {
                MessageBox.Show("You must type a water meter number if you want to delete one.",
                                "Stellar Water Point", MessageBoxButtons.OK, MessageBoxIcon.Information);
                return;
            }

            if (!File.Exists(strWaterMeters))
            {
                MessageBox.Show("There is no file for the water meters in the system.",
                                "Stellar Water Point",
                                MessageBoxButtons.OK, MessageBoxIcon.Information);
                return;
            }

            xdWaterMeters.Load(strWaterMeters);

            XmlNodeList xnlWaterMeters = xdWaterMeters.DocumentElement!.GetElementsByTagName("meter-number");

            foreach (XmlNode xnWaterMeter in xnlWaterMeters)
            {
                if (xnWaterMeter.InnerText == mtbMeterNumber.Text)
                {
                    if (MessageBox.Show("Are you sure you want to delete this water meter record from the system?",
                                    "Stellar Water Point",
                                    MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes)
                    {
                        xdWaterMeters.DocumentElement.RemoveChild(xnWaterMeter.ParentNode!);
                        break;
                    }
                }
            }

            xdWaterMeters.Save(strWaterMeters);

            /* XmlDocument xdWaterMeters = new XmlDocument();
            string? strWaterMeters = @"C:\Stellar Water Point\WaterMeters.xml";

            FileInfo? fiWaterMeters = new FileInfo(strWaterMeters);

            if (fiWaterMeters.Exists)
            {
                using (FileStream? fsWaterMeters = new FileStream(fiWaterMeters.FullName, FileMode.Open, FileAccess.Read, FileShare.Read))
                {
                    xdWaterMeters.Load(fsWaterMeters);
                    XmlNodeList xnlWaterMeters = xdWaterMeters.DocumentElement!.SelectNodes("//meter-number[.='" + mtbMeterNumber.Text + "']")!;

                    foreach (XmlNode xnWaterMeter in xnlWaterMeters)
                    {
                        xdWaterMeters.DocumentElement.RemoveChild(xnWaterMeter.ParentNode!);
                    }
                }

                using (FileStream? fsWaterMeters = new FileStream(fiWaterMeters.FullName, FileMode.OpenOrCreate, FileAccess.ReadWrite, FileShare.ReadWrite))
                {
                    xdWaterMeters.Save(fsWaterMeters);
                }

                using (FileStream? fsWaterMeters = new FileStream(fiWaterMeters.FullName, FileMode.OpenOrCreate, FileAccess.ReadWrite, FileShare.ReadWrite))
                {
                    xdWaterMeters.Load(fsWaterMeters);
                    XmlNodeList xnlWaterMeters = xdWaterMeters.DocumentElement!.ChildNodes;

                    foreach (XmlNode xnWaterMeter in xnlWaterMeters)
                    {
                        if (xnWaterMeter.FirstChild!.InnerText.Equals(mtbMeterNumber.Text))
                        {
                            xdWaterMeters.DocumentElement.RemoveChild(xnWaterMeter);
                            break;
                        }
                    }
                }

                using (FileStream? fsWaterMeters = new FileStream(fiWaterMeters.FullName, FileMode.OpenOrCreate, FileAccess.ReadWrite, FileShare.ReadWrite))
                {
                    xdWaterMeters.Save(fsWaterMeters);
                }
            } */

            Close();
        }

        private void btnClose_Click(object sender, EventArgs e)
        {
            Close();
        }
    }
}
