﻿using System.Xml;

namespace StellarWaterPoint.WaterMeters
{
    public partial class Editor : Form
    {
        public Editor()
        {
            InitializeComponent();
        }

        private void btnFind_Click(object sender, EventArgs e)
        {
            XmlDocument xdWaterMeters = new XmlDocument();
            string? strWaterMeters = @"C:\Stellar Water Point\WaterMeters.xml";

            FileInfo? fiWaterMeters = new FileInfo(strWaterMeters);

            if (fiWaterMeters.Exists)
            {
                using (FileStream? fsWaterMeters = new FileStream(fiWaterMeters.FullName, FileMode.Open, FileAccess.Read, FileShare.Read))
                {
                    xdWaterMeters.Load(fsWaterMeters);
                    XmlNodeList xnlWaterMeters = xdWaterMeters.DocumentElement!.SelectNodes("//meter-number[.='" + mtbMeterNumber.Text + "']")!;

                    foreach (XmlNode xnWaterMeter in xnlWaterMeters)
                    {
                        txtMake.Text = xnWaterMeter.NextSibling!.InnerText;
                        txtModel.Text = xnWaterMeter.NextSibling.NextSibling!.InnerText;
                        txtMeterSize.Text = xnWaterMeter.NextSibling.NextSibling.NextSibling!.InnerText;
                    }
                }
            }
        }

        private void btnUpdateWaterMeter_Click(object sender, EventArgs e)
        {
            XmlDocument xdWaterMeters = new XmlDocument();
            string? strWaterMeters = @"C:\Stellar Water Point\WaterMeters.xml";

            FileInfo? fiWaterMeters = new FileInfo(strWaterMeters);

            if (fiWaterMeters.Exists)
            {
                using (FileStream? fsWaterMeters = new FileStream(fiWaterMeters.FullName, FileMode.Open, FileAccess.Read, FileShare.Read))
                {
                    xdWaterMeters.Load(fsWaterMeters);
                    XmlNodeList xnlWaterMeters = xdWaterMeters.DocumentElement!.SelectNodes("//meter-number[.='" + mtbMeterNumber.Text + "']")!;

                    foreach (XmlNode xnWaterMeter in xnlWaterMeters)
                    {
                        xnWaterMeter.ParentNode!.InnerXml = "<meter-number>" + mtbMeterNumber.Text + "</meter-number>" +
                                                            "<make>" + txtMake.Text + "</make>" +
                                                            "<model>" + txtModel.Text + "</model>" +
                                                            "<meter-size>" + txtMeterSize.Text + "</meter-size>";
                    }
                }

                using (FileStream? fsWaterMeters = new FileStream(fiWaterMeters.FullName, FileMode.OpenOrCreate, FileAccess.ReadWrite, FileShare.ReadWrite))
                {
                    xdWaterMeters.Save(fsWaterMeters);
                }
            }

            Close();
        }

        private void btnClose_Click(object sender, EventArgs e)
        {
            Close();
        }
    }
}
